// Code generated by make gen-parquet-query. DO NOT EDIT.
// source: pkg/parquetquerygen/predicates.go

package parquetquery

import (
	"bytes"
	"fmt"

	pq "github.com/parquet-go/parquet-go"
)

var _ Predicate = (*IntEqualPredicate)(nil)

type IntEqualPredicate struct {
	value int64
}

func NewIntEqualPredicate(val int64) IntEqualPredicate {
	return IntEqualPredicate{value: val}
}

func (p IntEqualPredicate) String() string {
	return fmt.Sprintf("IntEqualPredicate{%d}", p.value)
}

func (p IntEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Int64()
			max := ci.MaxValue(i).Int64()

			if min <= p.value && p.value <= max {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.Int64()
		max := maxV.Int64()

		return min <= p.value && p.value <= max
	}

	return true
}

func (p IntEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv == p.value
}

var _ Predicate = (*IntNotEqualPredicate)(nil)

type IntNotEqualPredicate struct {
	value int64
}

func NewIntNotEqualPredicate(val int64) IntNotEqualPredicate {
	return IntNotEqualPredicate{value: val}
}

func (p IntNotEqualPredicate) String() string {
	return fmt.Sprintf("IntNotEqualPredicate{%d}", p.value)
}

func (p IntNotEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Int64()
			max := ci.MaxValue(i).Int64()

			if min != p.value || p.value != max {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntNotEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.Int64()
		max := maxV.Int64()

		return min != p.value || p.value != max
	}

	return true
}

func (p IntNotEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv != p.value
}

var _ Predicate = (*IntGreaterPredicate)(nil)

type IntGreaterPredicate struct {
	value int64
}

func NewIntGreaterPredicate(val int64) IntGreaterPredicate {
	return IntGreaterPredicate{value: val}
}

func (p IntGreaterPredicate) String() string {
	return fmt.Sprintf("IntGreaterPredicate{%d}", p.value)
}

func (p IntGreaterPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).Int64()

			if max > p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntGreaterPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.Int64()

		return max > p.value
	}

	return true
}

func (p IntGreaterPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv > p.value
}

var _ Predicate = (*IntGreaterEqualPredicate)(nil)

type IntGreaterEqualPredicate struct {
	value int64
}

func NewIntGreaterEqualPredicate(val int64) IntGreaterEqualPredicate {
	return IntGreaterEqualPredicate{value: val}
}

func (p IntGreaterEqualPredicate) String() string {
	return fmt.Sprintf("IntGreaterEqualPredicate{%d}", p.value)
}

func (p IntGreaterEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).Int64()

			if max >= p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntGreaterEqualPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.Int64()

		return max >= p.value
	}

	return true
}

func (p IntGreaterEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv >= p.value
}

var _ Predicate = (*IntLessPredicate)(nil)

type IntLessPredicate struct {
	value int64
}

func NewIntLessPredicate(val int64) IntLessPredicate {
	return IntLessPredicate{value: val}
}

func (p IntLessPredicate) String() string {
	return fmt.Sprintf("IntLessPredicate{%d}", p.value)
}

func (p IntLessPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Int64()
			

			if min < p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntLessPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.Int64()
		

		return min < p.value
	}

	return true
}

func (p IntLessPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv < p.value
}

var _ Predicate = (*IntLessEqualPredicate)(nil)

type IntLessEqualPredicate struct {
	value int64
}

func NewIntLessEqualPredicate(val int64) IntLessEqualPredicate {
	return IntLessEqualPredicate{value: val}
}

func (p IntLessEqualPredicate) String() string {
	return fmt.Sprintf("IntLessEqualPredicate{%d}", p.value)
}

func (p IntLessEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Int64()
			

			if min <= p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p IntLessEqualPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.Int64()
		

		return min <= p.value
	}

	return true
}

func (p IntLessEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Int64()
	return vv <= p.value
}

var _ Predicate = (*FloatEqualPredicate)(nil)

type FloatEqualPredicate struct {
	value float64
}

func NewFloatEqualPredicate(val float64) FloatEqualPredicate {
	return FloatEqualPredicate{value: val}
}

func (p FloatEqualPredicate) String() string {
	return fmt.Sprintf("FloatEqualPredicate{%f}", p.value)
}

func (p FloatEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Double()
			max := ci.MaxValue(i).Double()

			if min <= p.value && p.value <= max {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.Double()
		max := maxV.Double()

		return min <= p.value && p.value <= max
	}

	return true
}

func (p FloatEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv == p.value
}

var _ Predicate = (*FloatNotEqualPredicate)(nil)

type FloatNotEqualPredicate struct {
	value float64
}

func NewFloatNotEqualPredicate(val float64) FloatNotEqualPredicate {
	return FloatNotEqualPredicate{value: val}
}

func (p FloatNotEqualPredicate) String() string {
	return fmt.Sprintf("FloatNotEqualPredicate{%f}", p.value)
}

func (p FloatNotEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Double()
			max := ci.MaxValue(i).Double()

			if min != p.value || p.value != max {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatNotEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.Double()
		max := maxV.Double()

		return min != p.value || p.value != max
	}

	return true
}

func (p FloatNotEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv != p.value
}

var _ Predicate = (*FloatGreaterPredicate)(nil)

type FloatGreaterPredicate struct {
	value float64
}

func NewFloatGreaterPredicate(val float64) FloatGreaterPredicate {
	return FloatGreaterPredicate{value: val}
}

func (p FloatGreaterPredicate) String() string {
	return fmt.Sprintf("FloatGreaterPredicate{%f}", p.value)
}

func (p FloatGreaterPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).Double()

			if max > p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatGreaterPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.Double()

		return max > p.value
	}

	return true
}

func (p FloatGreaterPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv > p.value
}

var _ Predicate = (*FloatGreaterEqualPredicate)(nil)

type FloatGreaterEqualPredicate struct {
	value float64
}

func NewFloatGreaterEqualPredicate(val float64) FloatGreaterEqualPredicate {
	return FloatGreaterEqualPredicate{value: val}
}

func (p FloatGreaterEqualPredicate) String() string {
	return fmt.Sprintf("FloatGreaterEqualPredicate{%f}", p.value)
}

func (p FloatGreaterEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).Double()

			if max >= p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatGreaterEqualPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.Double()

		return max >= p.value
	}

	return true
}

func (p FloatGreaterEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv >= p.value
}

var _ Predicate = (*FloatLessPredicate)(nil)

type FloatLessPredicate struct {
	value float64
}

func NewFloatLessPredicate(val float64) FloatLessPredicate {
	return FloatLessPredicate{value: val}
}

func (p FloatLessPredicate) String() string {
	return fmt.Sprintf("FloatLessPredicate{%f}", p.value)
}

func (p FloatLessPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Double()
			

			if min < p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatLessPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.Double()
		

		return min < p.value
	}

	return true
}

func (p FloatLessPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv < p.value
}

var _ Predicate = (*FloatLessEqualPredicate)(nil)

type FloatLessEqualPredicate struct {
	value float64
}

func NewFloatLessEqualPredicate(val float64) FloatLessEqualPredicate {
	return FloatLessEqualPredicate{value: val}
}

func (p FloatLessEqualPredicate) String() string {
	return fmt.Sprintf("FloatLessEqualPredicate{%f}", p.value)
}

func (p FloatLessEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).Double()
			

			if min <= p.value {
				return true
			}
		}
		return false
	}

	return true
}

func (p FloatLessEqualPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.Double()
		

		return min <= p.value
	}

	return true
}

func (p FloatLessEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Double()
	return vv <= p.value
}

var _ Predicate = (*BoolEqualPredicate)(nil)

type BoolEqualPredicate struct {
	value bool
}

func NewBoolEqualPredicate(val bool) BoolEqualPredicate {
	return BoolEqualPredicate{value: val}
}

func (p BoolEqualPredicate) String() string {
	return fmt.Sprintf("BoolEqualPredicate{%t}", p.value)
}

func (p BoolEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}

	return true
}

func (p BoolEqualPredicate) KeepPage(page pq.Page) bool {

	return true
}

func (p BoolEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Boolean()
	return vv == p.value
}

var _ Predicate = (*BoolNotEqualPredicate)(nil)

type BoolNotEqualPredicate struct {
	value bool
}

func NewBoolNotEqualPredicate(val bool) BoolNotEqualPredicate {
	return BoolNotEqualPredicate{value: val}
}

func (p BoolNotEqualPredicate) String() string {
	return fmt.Sprintf("BoolNotEqualPredicate{%t}", p.value)
}

func (p BoolNotEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}

	return true
}

func (p BoolNotEqualPredicate) KeepPage(page pq.Page) bool {

	return true
}

func (p BoolNotEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.Boolean()
	return vv != p.value
}

var _ Predicate = (*StringEqualPredicate)(nil)

type StringEqualPredicate struct {
	value []byte
}

func NewStringEqualPredicate(val []byte) StringEqualPredicate {
	return StringEqualPredicate{value: val}
}

func (p StringEqualPredicate) String() string {
	return fmt.Sprintf("StringEqualPredicate{%s}", p.value)
}

func (p StringEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}

	return true
}

func (p StringEqualPredicate) KeepPage(page pq.Page) bool {

	return true
}

func (p StringEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Equal(vv, p.value)
}

var _ Predicate = (*StringNotEqualPredicate)(nil)

type StringNotEqualPredicate struct {
	value []byte
}

func NewStringNotEqualPredicate(val []byte) StringNotEqualPredicate {
	return StringNotEqualPredicate{value: val}
}

func (p StringNotEqualPredicate) String() string {
	return fmt.Sprintf("StringNotEqualPredicate{%s}", p.value)
}

func (p StringNotEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).ByteArray()
			max := ci.MaxValue(i).ByteArray()

			if !bytes.Equal(min, p.value) || !bytes.Equal(p.value, max) {
				return true
			}
		}
		return false
	}

	return true
}

func (p StringNotEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.ByteArray()
		max := maxV.ByteArray()

		return !bytes.Equal(min, p.value) || !bytes.Equal(p.value, max)
	}

	return true
}

func (p StringNotEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return !bytes.Equal(vv, p.value)
}

var _ Predicate = (*StringGreaterPredicate)(nil)

type StringGreaterPredicate struct {
	value []byte
}

func NewStringGreaterPredicate(val []byte) StringGreaterPredicate {
	return StringGreaterPredicate{value: val}
}

func (p StringGreaterPredicate) String() string {
	return fmt.Sprintf("StringGreaterPredicate{%s}", p.value)
}

func (p StringGreaterPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).ByteArray()

			if bytes.Compare(max, p.value) > 0 {
				return true
			}
		}
		return false
	}

	return true
}

func (p StringGreaterPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.ByteArray()

		return bytes.Compare(max, p.value) > 0
	}

	return true
}

func (p StringGreaterPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Compare(vv, p.value) > 0
}

var _ Predicate = (*StringGreaterEqualPredicate)(nil)

type StringGreaterEqualPredicate struct {
	value []byte
}

func NewStringGreaterEqualPredicate(val []byte) StringGreaterEqualPredicate {
	return StringGreaterEqualPredicate{value: val}
}

func (p StringGreaterEqualPredicate) String() string {
	return fmt.Sprintf("StringGreaterEqualPredicate{%s}", p.value)
}

func (p StringGreaterEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			
			max := ci.MaxValue(i).ByteArray()

			if bytes.Compare(max, p.value) >= 0 {
				return true
			}
		}
		return false
	}

	return true
}

func (p StringGreaterEqualPredicate) KeepPage(page pq.Page) bool {
	_, maxV, ok := page.Bounds()
	if ok {
		
		max := maxV.ByteArray()

		return bytes.Compare(max, p.value) >= 0
	}

	return true
}

func (p StringGreaterEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Compare(vv, p.value) >= 0
}

var _ Predicate = (*StringLessPredicate)(nil)

type StringLessPredicate struct {
	value []byte
}

func NewStringLessPredicate(val []byte) StringLessPredicate {
	return StringLessPredicate{value: val}
}

func (p StringLessPredicate) String() string {
	return fmt.Sprintf("StringLessPredicate{%s}", p.value)
}

func (p StringLessPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).ByteArray()
			

			if bytes.Compare(min, p.value) < 0 {
				return true
			}
		}
		return false
	}

	return true
}

func (p StringLessPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.ByteArray()
		

		return bytes.Compare(min, p.value) < 0
	}

	return true
}

func (p StringLessPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Compare(vv, p.value) < 0
}

var _ Predicate = (*StringLessEqualPredicate)(nil)

type StringLessEqualPredicate struct {
	value []byte
}

func NewStringLessEqualPredicate(val []byte) StringLessEqualPredicate {
	return StringLessEqualPredicate{value: val}
}

func (p StringLessEqualPredicate) String() string {
	return fmt.Sprintf("StringLessEqualPredicate{%s}", p.value)
}

func (p StringLessEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).ByteArray()
			

			if bytes.Compare(min, p.value) <= 0 {
				return true
			}
		}
		return false
	}

	return true
}

func (p StringLessEqualPredicate) KeepPage(page pq.Page) bool {
	minV, _, ok := page.Bounds()
	if ok {
		min := minV.ByteArray()
		

		return bytes.Compare(min, p.value) <= 0
	}

	return true
}

func (p StringLessEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Compare(vv, p.value) <= 0
}

var _ Predicate = (*ByteEqualPredicate)(nil)

type ByteEqualPredicate struct {
	value []byte
}

func NewByteEqualPredicate(val []byte) ByteEqualPredicate {
	return ByteEqualPredicate{value: val}
}

func (p ByteEqualPredicate) String() string {
	return fmt.Sprintf("ByteEqualPredicate{%s}", p.value)
}

func (p ByteEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).ByteArray()
			max := ci.MaxValue(i).ByteArray()

			if bytes.Compare(p.value, min) >= 0 && bytes.Compare(p.value, max) <= 0 {
				return true
			}
		}
		return false
	}

	return true
}

func (p ByteEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.ByteArray()
		max := maxV.ByteArray()

		return bytes.Compare(p.value, min) >= 0 && bytes.Compare(p.value, max) <= 0
	}

	return true
}

func (p ByteEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return bytes.Equal(bytes.TrimLeft(vv, "\x00"), p.value)
}

var _ Predicate = (*ByteNotEqualPredicate)(nil)

type ByteNotEqualPredicate struct {
	value []byte
}

func NewByteNotEqualPredicate(val []byte) ByteNotEqualPredicate {
	return ByteNotEqualPredicate{value: val}
}

func (p ByteNotEqualPredicate) String() string {
	return fmt.Sprintf("ByteNotEqualPredicate{%s}", p.value)
}

func (p ByteNotEqualPredicate) KeepColumnChunk(c *ColumnChunkHelper) bool {
	if d := c.Dictionary(); d != nil {
		return keepDictionary(d, p.KeepValue)
	}
	ci, err := c.ColumnIndex()
	if err == nil && ci != nil {
		for i := 0; i < ci.NumPages(); i++ {
			min := ci.MinValue(i).ByteArray()
			max := ci.MaxValue(i).ByteArray()

			if !bytes.Equal(min, p.value) || !bytes.Equal(p.value, max) {
				return true
			}
		}
		return false
	}

	return true
}

func (p ByteNotEqualPredicate) KeepPage(page pq.Page) bool {
	minV, maxV, ok := page.Bounds()
	if ok {
		min := minV.ByteArray()
		max := maxV.ByteArray()

		return !bytes.Equal(min, p.value) || !bytes.Equal(p.value, max)
	}

	return true
}

func (p ByteNotEqualPredicate) KeepValue(v pq.Value) bool {
	vv := v.ByteArray()
	return !bytes.Equal(bytes.TrimLeft(vv, "\x00"), p.value)
}
